/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

.nv-navigation-view {
  background-color: var(--nv-theme-alt-1);
  display: block;
  height: 100%;
  overflow-y: auto;
  padding: $space-md;
  width: 256px;

  .nv-nv-view-container {
    display: flex;
    flex-direction: column;
    position: relative;
    width: 100%;
  }

  //
  // Separator
  //

  .nv-navigation-view-separator {
    @extend .nv-hr;
    background-color: unset;
    border-color: var(--nv-border-color);
    display: block;
    margin-left: $space-default !important;
    margin-right: $space-default !important;
    width: calc(100% - #{$space-lg});
  }

  //
  // Header
  //

  .nv-nav-header {
    display: flex;
    margin-bottom: $space-md;
    
    width: 100%;
  }

  .nv-nav-item-header {
    cursor: default;
    display: block;
    padding: $space-sm 0;

    * {
      font-family: 'FiraGO Medium';
    }

    h1,
    h2,
    h3,
    h4,
    h5,
    h6,
    .nv-h1,
    .nv-h2,
    .nv-h3,
    .nv-h4,
    .nv-h5,
    .nv-h6 {
      margin-bottom: 0;
      margin-top: 0;
    }
  } 

  .nv-nav-title h6 {
    font-family: 'FiraGO Medium'; 
  }


  //
  // Items
  //

  .nv-nav-items {
    @extend .transition-exit;

    &.nv-nav-items-active {
      @extend .transition-exit;
      background-color: var(--nv-theme-alt-2);
    }
  }

  .nv-navigation-view-item {
    @extend .transition-exit;
    cursor: pointer;
    display: block;
    font-family: 'FiraGO Regular';
    padding: $space-default;
    position: relative;
    transition-property: background-color;

    &::before {
      @extend .transition-exit;

      background-color: var(--nv-theme-primary);
      content: '';
      height: 0%;
      left: 2px;
      position: absolute;
      top: 50%;
      transform: translateY(-50%);
      transform-origin: center;
      transition-property: height;
      width: 2px;
      z-index: 2;
    }

    &.nv-navigation-view-item-active {
      &::before {
        @extend .transition-entrance;
        height: 100%;
      }
    }

    &:hover {
      @extend .transition-entrance;
      background-color: var(--nv-theme-alt-2);
    }
  }

  .nv-nav-view-left-content,
  .nv-nav-view-center-content,
  .nv-nav-view-right-content {
    display: flex;
  }

  .nv-nav-view-left-content {
    flex-direction: column;
  }
  
  .nv-nav-view-right-content {
    align-items: center;
    white-space: nowrap;
  }

  .nv-nav-view-center-content {
    align-content: center;
    align-items: center;
    justify-content: center;
  }

  //
  // Modes
  //

  // Top

  &.nv-navigation-view-top {
    height: auto;
    padding-bottom: 0;
    padding-left: $space-default;
    padding-right: $space-default;
    padding-top: 0;
    position: sticky;
    top: 0;
    width: 100%;
    z-index: 1071;

    .nv-nv-view-container {
      flex-direction: row;
      height: 100%;
      justify-content: space-between;
      overflow: hidden;
      width: 100%;
    }
    

    .nv-nav-view-left-content,
    .nv-nav-view-right-content {
      align-items: center;
      flex-direction: row;
      white-space: nowrap;
    }

    .nv-nav-item-header {
      align-items: center;
      display: flex;
      padding-left: 0;

      h6 {
        padding-bottom: 0;
        padding-top: 0;
      }
    }

    //
    // Separator
    //

    .nv-navigation-view-separator {
      height: 50%;
      margin: 0 $space-default;
      width: 1px;
    }

    .nv-nav-items {
      align-items: center;
      display: flex;
      flex-wrap: nowrap;

      .nv-nav-item-header {
        margin-right: $space-default;
      }

      div {
        align-items: center;
        display: flex;
        flex-wrap: nowrap;
      }

      .nv-navigation-view-item {
        padding-bottom: $space-md;
        padding-top: $space-md;

        &::before {
          bottom: 0;
          height: 2px;
          left: 50%;
          top: unset;
          transform: translateX(-50%);
          transition-property: width;
          width: 0%;
        }
        
        &.nv-navigation-view-item-active::before {
          width: 100%;
        }
      }

    }

    .nv-nav-view-right-content {
      > *:not(:last-child) {
        margin-right: $space-default;
      }
    }
  }

  //
  // Positions
  // 

  &.nv-navigation-view-top-fixed {
    left: 0;
    position: fixed;
    top: 0;
  }
  
  //
  // Responsive
  //

  .nv-navigation-view-mb-menu {
    @extend .transition-exit;

    &::before {
      background-color: var(--nv-border-color);
      content: '';
      display: block;
      height: 1px;
      margin: 20px 0;
      width: 100%;
    }

    .nv-nav-items {
      width: 100%;
    }

    // Visibility
    &.nv-nav-view-mnmb-active {
      @extend .transition-entrance;
      height: auto;
      opacity: 1;
      visibility: visible;
    }
    
    &.nv-nav-view-mnmb-hidden {
      height: 8px !important;
      opacity: 1;
      overflow: hidden;
      visibility: visible;
    }

    .nv-navigation-view-separator {
      height: 1px;
      margin-bottom: $space-default;
      margin-left: 0;
      margin-right: 0;
      margin-top: $space-default;
      width: 100%;
    }
  }

  .nv-navigation-view-menu {
    align-items: center;
  }

  .nv-navigation-view-menu,
  .nv-navigation-view-mb-menu {
    display: none;
  }

  // Mobile menu style for Websites.

  &.nv-navigation-view-top-responsive {
    padding-top: $space-default;

    .nv-nav-view-search-box {
      display: block;
      margin: $space-md 0;

      nv-search-box {
        width: 100%;
      }
    }

    .nv-nv-view-container {
      flex-wrap: wrap;
    }

    .nv-navigation-view-menu {
      display: flex;
      margin-right: $space-md;
    }

    .nv-navigation-view-mb-menu {
      display: block;
      overflow-y: auto;
      width: 100%;
    }

    .nv-nav-item-header {
      padding-left: 0;
      padding-right: 0;

      h6,
      .nv-h6 {
        padding: unset;
      }
    }

    .nv-nav-items {
      flex-direction: row;
      flex-wrap: wrap;
      
      div {
        flex-direction: row;
        flex-wrap: wrap;
        width: 100%;
      }

      .nv-navigation-view-item {
        width: 100%;

        &::before {
          bottom: unset;
          height: 0;
          left: 2px;
          top: 50%;
          transform: translateY(-50%);
          transition-property: height;
          width: 2px !important;
        }

        &.nv-navigation-view-item-active::before {
          height: 100%;
        }
      }

      .nv-nav-item-header {
        margin-bottom: $space-default;
      }
    }

    .nv-nav-view-left-content,
    .nv-nav-view-center-content,
    .nv-nav-view-right-content {
      &:empty {
        display: none;
      }
    }

    .nv-nav-view-center-content {
      left: 50%;
      position: absolute;
      top: 50%;
      transform: translate(-50%, -50%);
      z-index: 1;
    }

    .nv-nav-view-left-content,
    .nv-nav-view-right-content {
      z-index: 4;
    }
  }
}
